=== debian/changelog ===
trompeloeil-cpp (43-3) unstable; urgency=medium

  * Added patches for full offline build
  * Marked package as Multi-Arch: Same

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Sun, 05 Feb 2023 14:06:59 +0100

trompeloeil-cpp (43-2) unstable; urgency=medium

  * Upload to unstable
  * Source-only upload

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Fri, 03 Feb 2023 14:18:26 +0100

trompeloeil-cpp (43-1) experimental; urgency=medium

  * Initial release. (Closes: #1029784)

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Fri, 03 Feb 2023 14:12:57 +0100
