=== debian/control ===
Source: trompeloeil-cpp
Section: libdevel
Priority: optional
Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 catch2,
Standards-Version: 4.6.2
Homepage: https://github.com/rollbear/trompeloeil
Vcs-Browser: https://salsa.debian.org/werdahias/trompeloeil-cpp
Vcs-Git: https://salsa.debian.org/werdahias/trompeloeil-cpp.git

Package: libtrompeloeil-cpp-dev
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: mocking framework for C++11/14
 A thread-safe header-only mocking framework for C++11/14.
 This is a header-only library.
