=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
BUILD_DIR=obj-$(DEB_HOST_GNU_TYPE)
include /usr/share/dpkg/architecture.mk

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Debug

execute_after_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd $(BUILD_DIR) && \
	cmake --build ./ -t self_test thread_terror custom_recursive_mutex -j$$((`nproc`-1))
endif

execute_after_dh_auto_test:
	 cd $(BUILD_DIR) && \
	 ./self_test && ./thread_terror && ./custom_recursive_mutex



override_dh_compress:
	dh_compress -X.pdf -X.md
