=== debian/changelog ===
trompeloeil-cpp (44-1) unstable; urgency=medium

  * Added cmake minimum version in d/rules
  * Drop parallelization in d/rules (Closes: #1031024)
  * Drop use-proper-catch.diff, amended allow-offline-build.diff

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Sun, 11 Jun 2023 13:17:15 +0200
