=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- cmake,
+ cmake (>= 3.14),
  catch2,
 Standards-Version: 4.6.2
 Homepage: https://github.com/rollbear/trompeloeil
