=== debian/rules ===
--- 
+++ 
@@ -14,14 +14,12 @@
 execute_after_dh_auto_build:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	cd $(BUILD_DIR) && \
-	cmake --build ./ -t self_test thread_terror custom_recursive_mutex -j$$((`nproc`-1))
+	cmake --build ./ -t self_test thread_terror custom_recursive_mutex 
 endif
 
 execute_after_dh_auto_test:
-	 cd $(BUILD_DIR) && \
+	 cd $(BUILD_DIR)/test && \
 	 ./self_test && ./thread_terror && ./custom_recursive_mutex
-
-
 
 override_dh_compress:
 	dh_compress -X.pdf -X.md
