=== debian/changelog ===
trompeloeil-cpp (46-1) unstable; urgency=medium

  * New upstream release 
  * Temporarily disable building of tests because catch2 
    is not available (Closes: #1054714, #1059495)
  * Updated my mail address in d/control and d/copyright

 -- Matthias Geiger <werdahias@riseup.net>  Sat, 30 Dec 2023 01:50:15 +0100
