## trompeloeil-cpp 47

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(trompeloeil)
+project(trompeloeil CXX)
 
 include(GNUInstallDirs)
 include(ExternalProject)
@@ -10,7 +10,7 @@
 
 write_basic_package_version_file(
   "${CMAKE_CURRENT_BINARY_DIR}/trompeloeil/trompeloeil-config-version.cmake"
-  VERSION 46
+  VERSION 47
   COMPATIBILITY AnyNewerVersion
   ARCH_INDEPENDENT)
