=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+cmake_minimum_required(VERSION 3.19)
+
 option(TROMPELOEIL_CATCH2_PREBUILT "Major version of prebuilt catch2")
 option(TROMPELOEIL_CATCH2_PREFIX "Path to catch2 installation")
 
@@ -210,12 +212,18 @@
 
 endif() # MSVC
 
+if (${CMAKE_CXX_STANDARD} GREATER_EQUAL 20)
+    set(CXX20TESTS "test_co_mock.cpp")
+else ()
+    set(CXX20TESTS "")
+endif ()
+
 add_executable(
         self_test
-        EXCLUDE_FROM_ALL
         compiling_tests.cpp
         compiling_tests_11.cpp
-        compiling_tests_14.cpp)
+        compiling_tests_14.cpp
+        ${CXX20TESTS})
 
 
 if (SANITIZE AND NOT APPLE)
@@ -242,7 +250,6 @@
 
 add_executable(
         thread_terror
-        EXCLUDE_FROM_ALL
         thread_terror.cpp
 )
 
@@ -266,7 +273,6 @@
 
 add_executable(
         custom_recursive_mutex
-        EXCLUDE_FROM_ALL
         custom_recursive_mutex.cpp
 )
