=== debian/changelog ===
trompeloeil-cpp (47-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:11:51 +1100

trompeloeil-cpp (47-1) unstable; urgency=medium

  * New upstream release 

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 01 Mar 2024 21:59:50 +0100
