=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: trompeloeil-cpp
 Section: libdevel
 Priority: optional
-Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
